code for caos
      program caos
c--Caos system
c  Crystal Analysis Operating System
c  versione per Windows (compilatore Intel Fortran 10.1)
c--18/09/1999
c--------------------------------
************************************************************************
*--Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
c
      character*60 weblog,wflog,wfinp,wfout,webout,webxout
      common/xweb/iweb,ncweb,ncwout
      common/xfweb/weblog,wflog,wfinp,wfout,webout,webxout
c--
      dimension param(4)
      character*60 cmenu,filex,file1,file2
      character*60 menu
      character*60 idfle,stfle
      common/cdisu/idfle,stfle
      character*60 inpnam,outnam
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/ioname/inpnam,outnam
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
      data cmenu/' '/,filex/' '/,file1/' '/,file2/' '/
c--
c--nuovo compattamento degli indici
      ifat512  = 512
      ifat512a = ( 2 * ifat512 + 1 ) * ( 2 * ifat512 + 1 )
      ifat512b = ( 2 * ifat512 + 1 )
c--
c--initialize i/o
c  filex binary file (structure project)
c  file1 input file
c  file2 output file
c
      if(jinit(filex,file1,file2).lt.0) then
       call zerr
       stop
      endif
c--initialize store buffers
      call star9
      call xtrig
c--check the line command
      call xcase(filex)
      call xcase(file1)
      call xcase(file2)
      if(filex.eq.' '.and.iweb.eq.0) goto 2000
c
      if (file1(1:1).ne.' ') then
       il=len(file1)
       do 2410 i=1,il
       if(file1(i:i).ne.inpnam(i:i)) goto 2420
2410   j=j+1
       goto 2450
2420   itty=0
       ncru=55
       nlen=80
       jop=jopen(ncru,file1,nlen,ier1)
       if (jop.lt.0) then
	  ier=-1
	  write(ncwu,5) ier1,file1
	  stop 3
       endif
      endif
2450  if (file2(1:1).ne.' ') then
       il=len(file2)
       do 2460 i=1,il
       if(file2(i:i).ne.outnam(i:i)) goto 2470
2460	 j=j+1
       goto 2000
2470   ncwu=66
       jop=iopen(ncwu,file2,ier2)
       if (jop.lt.0) then
	  ier=-1
	  write(ncwu,5) ier2,file2
	  stop 3
       endif
      endif
5     format(' *** error ***  open error, code =',i5,' file is ',a)
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c
c--caos da direttive
2000  key=-1
      if(filex.ne.' '.or.itty.eq.-1) then
       if(iflstd(filex,key).lt.0) then
	stop
       endif
      endif
      inn=0
      if(jkaos(key).lt.0) then
       call zerr
       stop
      endif
c--start loop sui comandi standard
2010  call srcmd(inn)
      if(jexecu(key,inn,param).ge.0) goto 2010
      call xendx
      stop
      end
c
code for jkaos
      function jkaos(key)
c--crystals analysis operating system
c  16/32 bits version compatible
c
c  initialize routine
c
      character*80 itemp
      character*60 carctr,ifmt
      common/cfile/ carctr,ifmt
      character*60 ititle
      common/compd/ititle
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60 idfle,stfle
      common/cdisu/idfle,stfle
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun,
     2 kkscr,llscr,psfle
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun,
     2 kkscr,llscr,psfle
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint,namh                           
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      common/xswtc/ npro,ipro(6,50),ndir(50),idir(200),jnd
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx   
c--
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      character*14 ibuf
      data ibuf/'Job started at'/
c--
      jkaos=0
c--jump heading if caos was called from a master main
      if(key.eq.0) return   
      call stim1(0)
      ni=0
c--print the heading
      write(ncwu,1100)
1100  format(' This is CAOS  (vers. 2002)',/,
     2 ' Crystal Analysis Operating System ')
      call prtdate(ibuf)
c--print the msg$ file
      i=jmsg(imsg,ncwu)
      call xline
      if(idfle.eq.' ') then
	if(itty.eq.-1) goto 1022
1030	call xcsae
	call xrsl
	je=1
	nt=80
	do 1041 i=je,nt
	image(i)=ib
1041	continue
	read(ncru,1050,end=1022)(image(j),j=je,nt)
1050	format(80a1)
	write(itemp,1050)image
	call xcase(itemp)
	read(itemp,1050) image
	ni=ni+1
	nc=1
c--check the '#' function
	if(image(nc)-ih) 1030,1080,1030
c--check for a comment card
1080	continue
	nc=2
	if(image(nc)-ib) 1091,1101,1091
c--check for end of card file
1091  continue
	if(image(nc)-ih) 1110,1022,1110
1101	continue
	call xpcci
	go to 1030
1110	continue
	if(kcsf(in)) 1022,1121,1022
1121	continue
	if(idfle.ne.' ') goto 1120
c--end of file situation                                                  
1022	continue
	call xnotc(i)
	call xefer
	stop 3
      end if
1120  continue
      call shift(idfle,lenp)
      write(ncwu,1122) idfle(1:lenp)
1122  format(' User file = ',a)
      call shift(ititle,lenp)
      write(ncwu,1020) ititle(1:lenp)
1020  format(1x,a,/)
      return
      end
c
code for iflstd
      function iflstd(filex,key)
c--input the binary file name (standard)
c  the property specifiers of this file are:
c  direct access
c  lenght of record is 2048 bytes  (pc)
c                   is 512 longwords  (vax)
c
      character*2 jaa,iyy
      character*60 carctr,filex,ifmt
      common/cfile/ carctr,ifmt
      character*60 ititle
      common/compd/ititle
      dimension itime(6)
cpc**	   character*8 itime(2)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60 idfle,stfle
      common/cdisu/idfle,stfle
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      common/xswtc/ npro,ipro(6,50),ndir(50),idir(200),jnd
c--
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      data iyy/'y'/
c
      iflstd=0
c--read the file name and open the binary file
coh***for o.h. computer the follow statement has
c  to be commented
      if(jfile(filex,key)) 2020,1030,1030
1030  continue
c--check the binary file
      call xdwn(lfirst,lindex,10)
      irecx=lindex(7)
c--	write(ncwu,*)'lfirst(a)...',lfirst,(lindex(i),i=1,10)
      if(lindex(8)-ifile) 1031,1035,1031
1035  continue
      if(lindex(9).ne.ifile) then
      call shift(idfle,lenp)
      write(intty,1040) idfle(1:lenp),idfle(1:lenp)
1040  format( ' user file= ',a,/,
     2	      ' The binary file is a old version file.',/,
     2        ' Probably you have to create new list 3 and 12',
     3	      ' and follow these instructions:',/,
     5	      ' #dump file',/,
     6	      ' nome_file',/,
     7	      ' #end',/,
     8	      ' $ CAOS ',a,' nome_file',/,
     9	      ' If you continue the flag will be reset and',/,
     *	      ' this message is no more displayed.',/,
     3	      ' Do you want to exit (y/n)? ',$)
      read(ncru,1041) jaa
1041  format(a )
      call xcase(jaa)
      if(jaa(1:1).eq.iyy) go to 2020
      call xdwn(lfirst,lindex,10)
      i=lindex(4)
      call xdwn (lfirst,lindex,i)
      lindex(9)=ifile
      call xup (lfirst,lindex,i)
      endif
      call sldf
      go to 1039
 1031 continue
      if(itty.eq.0) go to 1028
cdg**machine specific for vax and data general
cdg**the descriptor $ in an output format specification
cdg**will not output a new line character after  the
cdg**record
      write(intty,1026) idfle
1026  format(/' user file= ',a,/,
     *' do you want to initialize (y/n)? ',$)
      read(ncru,1027) jaa
1027  format(a )
      call xcase(jaa)
      if(jaa(1:1).ne.iyy) go to 2020
1028  continue
      call setfi
      write(ncwu,1032) idfle
1032  format(/' user file= ',a,/,
     *' has been initialized!!',/)
 1039 continue
      call xlc
      return
c
c--error
2020  continue
      iflstd=-1
      return
      end
c
code for jfile
      function jfile(filex,key)
c--assign the user binary file
c  the property specifiers of this file are:
c  direct access
c  lenght of record is 2048 bytes
c
      character*60 idfle,stfle,filex
      common/cdisu/idfle,stfle
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xfili/lfirst,nwblo,lindex(240)
c--
      common /SWareRC/ SWRC, HOMEdir, CAOSdir
      character*80 SWRC, Inte, NewL, HOMEdir, CAOSdir
      logical BACK
      character*1 slash
      character*4 ext
      character*60 itst1
      data ext/'.bin'/
      data slash/'\'/
      data itst1/'the binary file name (without extension) !'/
c--dummy statments
      keyc=key      
c
      jfile=0
      irecx=24
      if (filex.eq.' ') then
	itype=1
	call rdfile(itst1,ext,stfle,idfle,itype,ier)
	if(ier.ne.0) goto 1180
      else
	call setext(filex,ext,stfle)
	idfle=filex
      end if
!      
      k=index(idfle,slash,BACK = .TRUE.)
      if(k.gt.0) then
         SWRC=idfle(1:k)
      else
         ier=getcwd(SWRC)
         SWRC=NewL(1:Lung(SWRC))//slash
      endif
!      
      itype=0
c--	write(ncwu,*)' $',idfle,'$'
      if(kopen(ncdfu,idfle,ldaf,itype,ier)) 1150,1025,1025
1025  continue
      return
1150  continue
      write(ncwu,1160) ier
1160  format(' jfile: ',i5,' error')
1180  continue
      jfile=-1
      return
      end
c
code for jmsg
      function jmsg(name,ncwu)
c--print the $msg$ file (messages file)
c
      common/xnclu/ncmu,nctu,ncau,ncsu
      character*60 name
c--
      jmsg=0
      nlen=80
      if(jopens(ncmu,name,nlen,ier)) 9000,1000,1000
1000  call fiprt(ncmu,ncwu)
      close(ncmu,iostat=ier,err=9000)
      return
9000  continue
      jmsg=ier
      return
      end
